/*!
 * main.c
 *
 * Copyright (c) 2015, NADAL Jean-Baptiste. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 * 
 * @Author:  NADAL Jean-Baptiste
 * @Date: 09/12/2014
 *
 */

/*-------------------------------- INCLUDES ---------------------------------*/

#include <stdio.h>
#include <unistd.h>

#include "ubus-model.h"
#include "chacon.h"


/*!  ----------------------------------------------------------------------------
 *  @fn main
 *
 *  @brief Main function of Chacon Daemon.
 */
int main (int argc, char **argv)
{
	int thePin;
	int theRet = 0;

	if (argc != 2) {

		fprintf (stderr, "You should specify a WiringPI Pin ID\n");
		return -1;
	}

	thePin = atoi (argv[1]);

	if (setuid (0)) {

		perror ("setuid");
		return 1;
	}

	scheduler_realtime();

	/* Setup UBus. */
	theRet = SetupUbus ();
	if (theRet != 0) {

		fprintf (stderr, "Impossible to Setup the UBUS Environment.\n");
		return theRet;
	}

	/* Setup Chacon. */
	theRet = SetupChacon (thePin);
	if (theRet != 0) {

		fprintf (stderr, "Impossible to Setup the Chacon Environment.\n");
		return theRet;
	}

	/* Main loop */
	UBusMain ();

	scheduler_standard();

	return TerminateUBus();
}
